package org.eclipse.gef.dot.internal.language.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.gef.dot.internal.language.services.DotGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
@SuppressWarnings("all")
public class InternalDotParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "Subgraph", "Digraph", "Strict", "Graph", "Edge", "Node", "HyphenMinusHyphenMinus", "HyphenMinusGreaterThanSign", "Comma", "Colon", "Semicolon", "EqualsSign", "LeftSquareBracket", "RightSquareBracket", "LeftCurlyBracket", "RightCurlyBracket", "RULE_NUMERAL", "RULE_COMPASS_PT", "RULE_STRING", "RULE_QUOTED_STRING", "RULE_HTML_TAG_OPEN", "RULE_HTML_TAG_CLOSE", "RULE_HTML_CHARS", "RULE_HTML_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER"
    };
    public static final int HyphenMinusHyphenMinus=10;
    public static final int Node=9;
    public static final int RULE_STRING=22;
    public static final int RULE_NUMERAL=20;
    public static final int RULE_SL_COMMENT=29;
    public static final int Comma=12;
    public static final int EqualsSign=15;
    public static final int RULE_QUOTED_STRING=23;
    public static final int Strict=6;
    public static final int Colon=13;
    public static final int RightCurlyBracket=19;
    public static final int EOF=-1;
    public static final int RightSquareBracket=17;
    public static final int RULE_HTML_TAG_OPEN=24;
    public static final int RULE_WS=30;
    public static final int LeftCurlyBracket=18;
    public static final int RULE_ANY_OTHER=31;
    public static final int RULE_COMPASS_PT=21;
    public static final int RULE_HTML_TAG_CLOSE=25;
    public static final int Semicolon=14;
    public static final int Graph=7;
    public static final int Subgraph=4;
    public static final int RULE_HTML_STRING=27;
    public static final int RULE_ML_COMMENT=28;
    public static final int LeftSquareBracket=16;
    public static final int Digraph=5;
    public static final int HyphenMinusGreaterThanSign=11;
    public static final int RULE_HTML_CHARS=26;
    public static final int Edge=8;

    // delegates
    // delegators


        public InternalDotParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDotParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDotParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDotParser.g"; }



     	private DotGrammarAccess grammarAccess;

        public InternalDotParser(TokenStream input, DotGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "DotAst";
       	}

       	@Override
       	protected DotGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleDotAst"
    // InternalDotParser.g:58:1: entryRuleDotAst returns [EObject current=null] : iv_ruleDotAst= ruleDotAst EOF ;
    public final EObject entryRuleDotAst() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDotAst = null;


        try {
            // InternalDotParser.g:58:47: (iv_ruleDotAst= ruleDotAst EOF )
            // InternalDotParser.g:59:2: iv_ruleDotAst= ruleDotAst EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getDotAstRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleDotAst=ruleDotAst();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleDotAst; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDotAst"


    // $ANTLR start "ruleDotAst"
    // InternalDotParser.g:65:1: ruleDotAst returns [EObject current=null] : ( (lv_graphs_0_0= ruleDotGraph ) )* ;
    public final EObject ruleDotAst() throws RecognitionException {
        EObject current = null;

        EObject lv_graphs_0_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:71:2: ( ( (lv_graphs_0_0= ruleDotGraph ) )* )
            // InternalDotParser.g:72:2: ( (lv_graphs_0_0= ruleDotGraph ) )*
            {
            // InternalDotParser.g:72:2: ( (lv_graphs_0_0= ruleDotGraph ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=Digraph && LA1_0<=Graph)) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalDotParser.g:73:3: (lv_graphs_0_0= ruleDotGraph )
            	    {
            	    // InternalDotParser.g:73:3: (lv_graphs_0_0= ruleDotGraph )
            	    // InternalDotParser.g:74:4: lv_graphs_0_0= ruleDotGraph
            	    {
            	    if ( state.backtracking==0 ) {

            	      				newCompositeNode(grammarAccess.getDotAstAccess().getGraphsDotGraphParserRuleCall_0());
            	      			
            	    }
            	    pushFollow(FOLLOW_3);
            	    lv_graphs_0_0=ruleDotGraph();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      				if (current==null) {
            	      					current = createModelElementForParent(grammarAccess.getDotAstRule());
            	      				}
            	      				add(
            	      					current,
            	      					"graphs",
            	      					lv_graphs_0_0,
            	      					"org.eclipse.gef.dot.internal.language.Dot.DotGraph");
            	      				afterParserOrEnumRuleCall();
            	      			
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDotAst"


    // $ANTLR start "entryRuleDotGraph"
    // InternalDotParser.g:94:1: entryRuleDotGraph returns [EObject current=null] : iv_ruleDotGraph= ruleDotGraph EOF ;
    public final EObject entryRuleDotGraph() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDotGraph = null;


        try {
            // InternalDotParser.g:94:49: (iv_ruleDotGraph= ruleDotGraph EOF )
            // InternalDotParser.g:95:2: iv_ruleDotGraph= ruleDotGraph EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getDotGraphRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleDotGraph=ruleDotGraph();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleDotGraph; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDotGraph"


    // $ANTLR start "ruleDotGraph"
    // InternalDotParser.g:101:1: ruleDotGraph returns [EObject current=null] : ( ( (lv_strict_0_0= Strict ) )? ( (lv_type_1_0= ruleGraphType ) ) ( (lv_name_2_0= ruleID ) )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket ) ;
    public final EObject ruleDotGraph() throws RecognitionException {
        EObject current = null;

        Token lv_strict_0_0=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Enumerator lv_type_1_0 = null;

        AntlrDatatypeRuleToken lv_name_2_0 = null;

        EObject lv_stmts_4_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:107:2: ( ( ( (lv_strict_0_0= Strict ) )? ( (lv_type_1_0= ruleGraphType ) ) ( (lv_name_2_0= ruleID ) )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket ) )
            // InternalDotParser.g:108:2: ( ( (lv_strict_0_0= Strict ) )? ( (lv_type_1_0= ruleGraphType ) ) ( (lv_name_2_0= ruleID ) )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket )
            {
            // InternalDotParser.g:108:2: ( ( (lv_strict_0_0= Strict ) )? ( (lv_type_1_0= ruleGraphType ) ) ( (lv_name_2_0= ruleID ) )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket )
            // InternalDotParser.g:109:3: ( (lv_strict_0_0= Strict ) )? ( (lv_type_1_0= ruleGraphType ) ) ( (lv_name_2_0= ruleID ) )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket
            {
            // InternalDotParser.g:109:3: ( (lv_strict_0_0= Strict ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==Strict) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDotParser.g:110:4: (lv_strict_0_0= Strict )
                    {
                    // InternalDotParser.g:110:4: (lv_strict_0_0= Strict )
                    // InternalDotParser.g:111:5: lv_strict_0_0= Strict
                    {
                    lv_strict_0_0=(Token)match(input,Strict,FOLLOW_4); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(lv_strict_0_0, grammarAccess.getDotGraphAccess().getStrictStrictKeyword_0_0());
                      				
                    }
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElement(grammarAccess.getDotGraphRule());
                      					}
                      					setWithLastConsumed(current, "strict", lv_strict_0_0 != null, "strict");
                      				
                    }

                    }


                    }
                    break;

            }

            // InternalDotParser.g:123:3: ( (lv_type_1_0= ruleGraphType ) )
            // InternalDotParser.g:124:4: (lv_type_1_0= ruleGraphType )
            {
            // InternalDotParser.g:124:4: (lv_type_1_0= ruleGraphType )
            // InternalDotParser.g:125:5: lv_type_1_0= ruleGraphType
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getDotGraphAccess().getTypeGraphTypeEnumRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_5);
            lv_type_1_0=ruleGraphType();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getDotGraphRule());
              					}
              					set(
              						current,
              						"type",
              						lv_type_1_0,
              						"org.eclipse.gef.dot.internal.language.Dot.GraphType");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDotParser.g:142:3: ( (lv_name_2_0= ruleID ) )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( ((LA3_0>=RULE_NUMERAL && LA3_0<=RULE_QUOTED_STRING)||LA3_0==RULE_HTML_STRING) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // InternalDotParser.g:143:4: (lv_name_2_0= ruleID )
                    {
                    // InternalDotParser.g:143:4: (lv_name_2_0= ruleID )
                    // InternalDotParser.g:144:5: lv_name_2_0= ruleID
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getDotGraphAccess().getNameIDParserRuleCall_2_0());
                      				
                    }
                    pushFollow(FOLLOW_6);
                    lv_name_2_0=ruleID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getDotGraphRule());
                      					}
                      					set(
                      						current,
                      						"name",
                      						lv_name_2_0,
                      						"org.eclipse.gef.dot.internal.language.Dot.ID");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }

            otherlv_3=(Token)match(input,LeftCurlyBracket,FOLLOW_7); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getDotGraphAccess().getLeftCurlyBracketKeyword_3());
              		
            }
            // InternalDotParser.g:165:3: ( (lv_stmts_4_0= ruleStmt ) )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==Subgraph||(LA4_0>=Graph && LA4_0<=Node)||LA4_0==LeftCurlyBracket||(LA4_0>=RULE_NUMERAL && LA4_0<=RULE_QUOTED_STRING)||LA4_0==RULE_HTML_STRING) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // InternalDotParser.g:166:4: (lv_stmts_4_0= ruleStmt )
            	    {
            	    // InternalDotParser.g:166:4: (lv_stmts_4_0= ruleStmt )
            	    // InternalDotParser.g:167:5: lv_stmts_4_0= ruleStmt
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getDotGraphAccess().getStmtsStmtParserRuleCall_4_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_7);
            	    lv_stmts_4_0=ruleStmt();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getDotGraphRule());
            	      					}
            	      					add(
            	      						current,
            	      						"stmts",
            	      						lv_stmts_4_0,
            	      						"org.eclipse.gef.dot.internal.language.Dot.Stmt");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

            otherlv_5=(Token)match(input,RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_5, grammarAccess.getDotGraphAccess().getRightCurlyBracketKeyword_5());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDotGraph"


    // $ANTLR start "entryRuleStmt"
    // InternalDotParser.g:192:1: entryRuleStmt returns [EObject current=null] : iv_ruleStmt= ruleStmt EOF ;
    public final EObject entryRuleStmt() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleStmt = null;


        try {
            // InternalDotParser.g:192:45: (iv_ruleStmt= ruleStmt EOF )
            // InternalDotParser.g:193:2: iv_ruleStmt= ruleStmt EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getStmtRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleStmt=ruleStmt();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleStmt; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStmt"


    // $ANTLR start "ruleStmt"
    // InternalDotParser.g:199:1: ruleStmt returns [EObject current=null] : ( (this_NodeStmt_0= ruleNodeStmt | this_EdgeStmtNode_1= ruleEdgeStmtNode | this_AttrStmt_2= ruleAttrStmt | this_Attribute_3= ruleAttribute | this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph ) (otherlv_5= Semicolon )? ) ;
    public final EObject ruleStmt() throws RecognitionException {
        EObject current = null;

        Token otherlv_5=null;
        EObject this_NodeStmt_0 = null;

        EObject this_EdgeStmtNode_1 = null;

        EObject this_AttrStmt_2 = null;

        EObject this_Attribute_3 = null;

        EObject this_SubgraphOrEdgeStmtSubgraph_4 = null;



        	enterRule();

        try {
            // InternalDotParser.g:205:2: ( ( (this_NodeStmt_0= ruleNodeStmt | this_EdgeStmtNode_1= ruleEdgeStmtNode | this_AttrStmt_2= ruleAttrStmt | this_Attribute_3= ruleAttribute | this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph ) (otherlv_5= Semicolon )? ) )
            // InternalDotParser.g:206:2: ( (this_NodeStmt_0= ruleNodeStmt | this_EdgeStmtNode_1= ruleEdgeStmtNode | this_AttrStmt_2= ruleAttrStmt | this_Attribute_3= ruleAttribute | this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph ) (otherlv_5= Semicolon )? )
            {
            // InternalDotParser.g:206:2: ( (this_NodeStmt_0= ruleNodeStmt | this_EdgeStmtNode_1= ruleEdgeStmtNode | this_AttrStmt_2= ruleAttrStmt | this_Attribute_3= ruleAttribute | this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph ) (otherlv_5= Semicolon )? )
            // InternalDotParser.g:207:3: (this_NodeStmt_0= ruleNodeStmt | this_EdgeStmtNode_1= ruleEdgeStmtNode | this_AttrStmt_2= ruleAttrStmt | this_Attribute_3= ruleAttribute | this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph ) (otherlv_5= Semicolon )?
            {
            // InternalDotParser.g:207:3: (this_NodeStmt_0= ruleNodeStmt | this_EdgeStmtNode_1= ruleEdgeStmtNode | this_AttrStmt_2= ruleAttrStmt | this_Attribute_3= ruleAttribute | this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph )
            int alt5=5;
            alt5 = dfa5.predict(input);
            switch (alt5) {
                case 1 :
                    // InternalDotParser.g:208:4: this_NodeStmt_0= ruleNodeStmt
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getStmtAccess().getNodeStmtParserRuleCall_0_0());
                      			
                    }
                    pushFollow(FOLLOW_8);
                    this_NodeStmt_0=ruleNodeStmt();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_NodeStmt_0;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;
                case 2 :
                    // InternalDotParser.g:217:4: this_EdgeStmtNode_1= ruleEdgeStmtNode
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getStmtAccess().getEdgeStmtNodeParserRuleCall_0_1());
                      			
                    }
                    pushFollow(FOLLOW_8);
                    this_EdgeStmtNode_1=ruleEdgeStmtNode();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_EdgeStmtNode_1;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;
                case 3 :
                    // InternalDotParser.g:226:4: this_AttrStmt_2= ruleAttrStmt
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getStmtAccess().getAttrStmtParserRuleCall_0_2());
                      			
                    }
                    pushFollow(FOLLOW_8);
                    this_AttrStmt_2=ruleAttrStmt();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_AttrStmt_2;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;
                case 4 :
                    // InternalDotParser.g:235:4: this_Attribute_3= ruleAttribute
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getStmtAccess().getAttributeParserRuleCall_0_3());
                      			
                    }
                    pushFollow(FOLLOW_8);
                    this_Attribute_3=ruleAttribute();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_Attribute_3;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;
                case 5 :
                    // InternalDotParser.g:244:4: this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph
                    {
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getStmtAccess().getSubgraphOrEdgeStmtSubgraphParserRuleCall_0_4());
                      			
                    }
                    pushFollow(FOLLOW_8);
                    this_SubgraphOrEdgeStmtSubgraph_4=ruleSubgraphOrEdgeStmtSubgraph();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = this_SubgraphOrEdgeStmtSubgraph_4;
                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;

            }

            // InternalDotParser.g:253:3: (otherlv_5= Semicolon )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==Semicolon) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalDotParser.g:254:4: otherlv_5= Semicolon
                    {
                    otherlv_5=(Token)match(input,Semicolon,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_5, grammarAccess.getStmtAccess().getSemicolonKeyword_1());
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStmt"


    // $ANTLR start "entryRuleEdgeStmtNode"
    // InternalDotParser.g:263:1: entryRuleEdgeStmtNode returns [EObject current=null] : iv_ruleEdgeStmtNode= ruleEdgeStmtNode EOF ;
    public final EObject entryRuleEdgeStmtNode() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEdgeStmtNode = null;


        try {
            // InternalDotParser.g:263:53: (iv_ruleEdgeStmtNode= ruleEdgeStmtNode EOF )
            // InternalDotParser.g:264:2: iv_ruleEdgeStmtNode= ruleEdgeStmtNode EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEdgeStmtNodeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEdgeStmtNode=ruleEdgeStmtNode();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEdgeStmtNode; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEdgeStmtNode"


    // $ANTLR start "ruleEdgeStmtNode"
    // InternalDotParser.g:270:1: ruleEdgeStmtNode returns [EObject current=null] : ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_edgeRHS_1_0= ruleEdgeRhs ) )+ ( (lv_attrLists_2_0= ruleAttrList ) )* ) ;
    public final EObject ruleEdgeStmtNode() throws RecognitionException {
        EObject current = null;

        EObject lv_node_0_0 = null;

        EObject lv_edgeRHS_1_0 = null;

        EObject lv_attrLists_2_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:276:2: ( ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_edgeRHS_1_0= ruleEdgeRhs ) )+ ( (lv_attrLists_2_0= ruleAttrList ) )* ) )
            // InternalDotParser.g:277:2: ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_edgeRHS_1_0= ruleEdgeRhs ) )+ ( (lv_attrLists_2_0= ruleAttrList ) )* )
            {
            // InternalDotParser.g:277:2: ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_edgeRHS_1_0= ruleEdgeRhs ) )+ ( (lv_attrLists_2_0= ruleAttrList ) )* )
            // InternalDotParser.g:278:3: ( (lv_node_0_0= ruleNodeId ) ) ( (lv_edgeRHS_1_0= ruleEdgeRhs ) )+ ( (lv_attrLists_2_0= ruleAttrList ) )*
            {
            // InternalDotParser.g:278:3: ( (lv_node_0_0= ruleNodeId ) )
            // InternalDotParser.g:279:4: (lv_node_0_0= ruleNodeId )
            {
            // InternalDotParser.g:279:4: (lv_node_0_0= ruleNodeId )
            // InternalDotParser.g:280:5: lv_node_0_0= ruleNodeId
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getEdgeStmtNodeAccess().getNodeNodeIdParserRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_9);
            lv_node_0_0=ruleNodeId();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getEdgeStmtNodeRule());
              					}
              					set(
              						current,
              						"node",
              						lv_node_0_0,
              						"org.eclipse.gef.dot.internal.language.Dot.NodeId");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDotParser.g:297:3: ( (lv_edgeRHS_1_0= ruleEdgeRhs ) )+
            int cnt7=0;
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>=HyphenMinusHyphenMinus && LA7_0<=HyphenMinusGreaterThanSign)) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalDotParser.g:298:4: (lv_edgeRHS_1_0= ruleEdgeRhs )
            	    {
            	    // InternalDotParser.g:298:4: (lv_edgeRHS_1_0= ruleEdgeRhs )
            	    // InternalDotParser.g:299:5: lv_edgeRHS_1_0= ruleEdgeRhs
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getEdgeStmtNodeAccess().getEdgeRHSEdgeRhsParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_10);
            	    lv_edgeRHS_1_0=ruleEdgeRhs();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getEdgeStmtNodeRule());
            	      					}
            	      					add(
            	      						current,
            	      						"edgeRHS",
            	      						lv_edgeRHS_1_0,
            	      						"org.eclipse.gef.dot.internal.language.Dot.EdgeRhs");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt7 >= 1 ) break loop7;
            	    if (state.backtracking>0) {state.failed=true; return current;}
                        EarlyExitException eee =
                            new EarlyExitException(7, input);
                        throw eee;
                }
                cnt7++;
            } while (true);

            // InternalDotParser.g:316:3: ( (lv_attrLists_2_0= ruleAttrList ) )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==LeftSquareBracket) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // InternalDotParser.g:317:4: (lv_attrLists_2_0= ruleAttrList )
            	    {
            	    // InternalDotParser.g:317:4: (lv_attrLists_2_0= ruleAttrList )
            	    // InternalDotParser.g:318:5: lv_attrLists_2_0= ruleAttrList
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getEdgeStmtNodeAccess().getAttrListsAttrListParserRuleCall_2_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_11);
            	    lv_attrLists_2_0=ruleAttrList();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getEdgeStmtNodeRule());
            	      					}
            	      					add(
            	      						current,
            	      						"attrLists",
            	      						lv_attrLists_2_0,
            	      						"org.eclipse.gef.dot.internal.language.Dot.AttrList");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEdgeStmtNode"


    // $ANTLR start "entryRuleNodeStmt"
    // InternalDotParser.g:339:1: entryRuleNodeStmt returns [EObject current=null] : iv_ruleNodeStmt= ruleNodeStmt EOF ;
    public final EObject entryRuleNodeStmt() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleNodeStmt = null;


        try {
            // InternalDotParser.g:339:49: (iv_ruleNodeStmt= ruleNodeStmt EOF )
            // InternalDotParser.g:340:2: iv_ruleNodeStmt= ruleNodeStmt EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getNodeStmtRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleNodeStmt=ruleNodeStmt();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleNodeStmt; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleNodeStmt"


    // $ANTLR start "ruleNodeStmt"
    // InternalDotParser.g:346:1: ruleNodeStmt returns [EObject current=null] : ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_attrLists_1_0= ruleAttrList ) )* ) ;
    public final EObject ruleNodeStmt() throws RecognitionException {
        EObject current = null;

        EObject lv_node_0_0 = null;

        EObject lv_attrLists_1_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:352:2: ( ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_attrLists_1_0= ruleAttrList ) )* ) )
            // InternalDotParser.g:353:2: ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_attrLists_1_0= ruleAttrList ) )* )
            {
            // InternalDotParser.g:353:2: ( ( (lv_node_0_0= ruleNodeId ) ) ( (lv_attrLists_1_0= ruleAttrList ) )* )
            // InternalDotParser.g:354:3: ( (lv_node_0_0= ruleNodeId ) ) ( (lv_attrLists_1_0= ruleAttrList ) )*
            {
            // InternalDotParser.g:354:3: ( (lv_node_0_0= ruleNodeId ) )
            // InternalDotParser.g:355:4: (lv_node_0_0= ruleNodeId )
            {
            // InternalDotParser.g:355:4: (lv_node_0_0= ruleNodeId )
            // InternalDotParser.g:356:5: lv_node_0_0= ruleNodeId
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getNodeStmtAccess().getNodeNodeIdParserRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_11);
            lv_node_0_0=ruleNodeId();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getNodeStmtRule());
              					}
              					set(
              						current,
              						"node",
              						lv_node_0_0,
              						"org.eclipse.gef.dot.internal.language.Dot.NodeId");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDotParser.g:373:3: ( (lv_attrLists_1_0= ruleAttrList ) )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( (LA9_0==LeftSquareBracket) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // InternalDotParser.g:374:4: (lv_attrLists_1_0= ruleAttrList )
            	    {
            	    // InternalDotParser.g:374:4: (lv_attrLists_1_0= ruleAttrList )
            	    // InternalDotParser.g:375:5: lv_attrLists_1_0= ruleAttrList
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getNodeStmtAccess().getAttrListsAttrListParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_11);
            	    lv_attrLists_1_0=ruleAttrList();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getNodeStmtRule());
            	      					}
            	      					add(
            	      						current,
            	      						"attrLists",
            	      						lv_attrLists_1_0,
            	      						"org.eclipse.gef.dot.internal.language.Dot.AttrList");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleNodeStmt"


    // $ANTLR start "entryRuleAttrStmt"
    // InternalDotParser.g:396:1: entryRuleAttrStmt returns [EObject current=null] : iv_ruleAttrStmt= ruleAttrStmt EOF ;
    public final EObject entryRuleAttrStmt() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAttrStmt = null;


        try {
            // InternalDotParser.g:396:49: (iv_ruleAttrStmt= ruleAttrStmt EOF )
            // InternalDotParser.g:397:2: iv_ruleAttrStmt= ruleAttrStmt EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getAttrStmtRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleAttrStmt=ruleAttrStmt();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleAttrStmt; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAttrStmt"


    // $ANTLR start "ruleAttrStmt"
    // InternalDotParser.g:403:1: ruleAttrStmt returns [EObject current=null] : ( ( (lv_type_0_0= ruleAttributeType ) ) ( (lv_attrLists_1_0= ruleAttrList ) )+ ) ;
    public final EObject ruleAttrStmt() throws RecognitionException {
        EObject current = null;

        Enumerator lv_type_0_0 = null;

        EObject lv_attrLists_1_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:409:2: ( ( ( (lv_type_0_0= ruleAttributeType ) ) ( (lv_attrLists_1_0= ruleAttrList ) )+ ) )
            // InternalDotParser.g:410:2: ( ( (lv_type_0_0= ruleAttributeType ) ) ( (lv_attrLists_1_0= ruleAttrList ) )+ )
            {
            // InternalDotParser.g:410:2: ( ( (lv_type_0_0= ruleAttributeType ) ) ( (lv_attrLists_1_0= ruleAttrList ) )+ )
            // InternalDotParser.g:411:3: ( (lv_type_0_0= ruleAttributeType ) ) ( (lv_attrLists_1_0= ruleAttrList ) )+
            {
            // InternalDotParser.g:411:3: ( (lv_type_0_0= ruleAttributeType ) )
            // InternalDotParser.g:412:4: (lv_type_0_0= ruleAttributeType )
            {
            // InternalDotParser.g:412:4: (lv_type_0_0= ruleAttributeType )
            // InternalDotParser.g:413:5: lv_type_0_0= ruleAttributeType
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getAttrStmtAccess().getTypeAttributeTypeEnumRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_12);
            lv_type_0_0=ruleAttributeType();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getAttrStmtRule());
              					}
              					set(
              						current,
              						"type",
              						lv_type_0_0,
              						"org.eclipse.gef.dot.internal.language.Dot.AttributeType");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDotParser.g:430:3: ( (lv_attrLists_1_0= ruleAttrList ) )+
            int cnt10=0;
            loop10:
            do {
                int alt10=2;
                int LA10_0 = input.LA(1);

                if ( (LA10_0==LeftSquareBracket) ) {
                    alt10=1;
                }


                switch (alt10) {
            	case 1 :
            	    // InternalDotParser.g:431:4: (lv_attrLists_1_0= ruleAttrList )
            	    {
            	    // InternalDotParser.g:431:4: (lv_attrLists_1_0= ruleAttrList )
            	    // InternalDotParser.g:432:5: lv_attrLists_1_0= ruleAttrList
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getAttrStmtAccess().getAttrListsAttrListParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_11);
            	    lv_attrLists_1_0=ruleAttrList();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getAttrStmtRule());
            	      					}
            	      					add(
            	      						current,
            	      						"attrLists",
            	      						lv_attrLists_1_0,
            	      						"org.eclipse.gef.dot.internal.language.Dot.AttrList");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt10 >= 1 ) break loop10;
            	    if (state.backtracking>0) {state.failed=true; return current;}
                        EarlyExitException eee =
                            new EarlyExitException(10, input);
                        throw eee;
                }
                cnt10++;
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAttrStmt"


    // $ANTLR start "entryRuleAttrList"
    // InternalDotParser.g:453:1: entryRuleAttrList returns [EObject current=null] : iv_ruleAttrList= ruleAttrList EOF ;
    public final EObject entryRuleAttrList() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAttrList = null;


        try {
            // InternalDotParser.g:453:49: (iv_ruleAttrList= ruleAttrList EOF )
            // InternalDotParser.g:454:2: iv_ruleAttrList= ruleAttrList EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getAttrListRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleAttrList=ruleAttrList();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleAttrList; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAttrList"


    // $ANTLR start "ruleAttrList"
    // InternalDotParser.g:460:1: ruleAttrList returns [EObject current=null] : ( () otherlv_1= LeftSquareBracket ( ( (lv_attributes_2_0= ruleAttribute ) ) (otherlv_3= Comma | otherlv_4= Semicolon )? )* otherlv_5= RightSquareBracket ) ;
    public final EObject ruleAttrList() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        EObject lv_attributes_2_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:466:2: ( ( () otherlv_1= LeftSquareBracket ( ( (lv_attributes_2_0= ruleAttribute ) ) (otherlv_3= Comma | otherlv_4= Semicolon )? )* otherlv_5= RightSquareBracket ) )
            // InternalDotParser.g:467:2: ( () otherlv_1= LeftSquareBracket ( ( (lv_attributes_2_0= ruleAttribute ) ) (otherlv_3= Comma | otherlv_4= Semicolon )? )* otherlv_5= RightSquareBracket )
            {
            // InternalDotParser.g:467:2: ( () otherlv_1= LeftSquareBracket ( ( (lv_attributes_2_0= ruleAttribute ) ) (otherlv_3= Comma | otherlv_4= Semicolon )? )* otherlv_5= RightSquareBracket )
            // InternalDotParser.g:468:3: () otherlv_1= LeftSquareBracket ( ( (lv_attributes_2_0= ruleAttribute ) ) (otherlv_3= Comma | otherlv_4= Semicolon )? )* otherlv_5= RightSquareBracket
            {
            // InternalDotParser.g:468:3: ()
            // InternalDotParser.g:469:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getAttrListAccess().getAttrListAction_0(),
              					current);
              			
            }

            }

            otherlv_1=(Token)match(input,LeftSquareBracket,FOLLOW_13); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getAttrListAccess().getLeftSquareBracketKeyword_1());
              		
            }
            // InternalDotParser.g:479:3: ( ( (lv_attributes_2_0= ruleAttribute ) ) (otherlv_3= Comma | otherlv_4= Semicolon )? )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( ((LA12_0>=RULE_NUMERAL && LA12_0<=RULE_QUOTED_STRING)||LA12_0==RULE_HTML_STRING) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // InternalDotParser.g:480:4: ( (lv_attributes_2_0= ruleAttribute ) ) (otherlv_3= Comma | otherlv_4= Semicolon )?
            	    {
            	    // InternalDotParser.g:480:4: ( (lv_attributes_2_0= ruleAttribute ) )
            	    // InternalDotParser.g:481:5: (lv_attributes_2_0= ruleAttribute )
            	    {
            	    // InternalDotParser.g:481:5: (lv_attributes_2_0= ruleAttribute )
            	    // InternalDotParser.g:482:6: lv_attributes_2_0= ruleAttribute
            	    {
            	    if ( state.backtracking==0 ) {

            	      						newCompositeNode(grammarAccess.getAttrListAccess().getAttributesAttributeParserRuleCall_2_0_0());
            	      					
            	    }
            	    pushFollow(FOLLOW_14);
            	    lv_attributes_2_0=ruleAttribute();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      						if (current==null) {
            	      							current = createModelElementForParent(grammarAccess.getAttrListRule());
            	      						}
            	      						add(
            	      							current,
            	      							"attributes",
            	      							lv_attributes_2_0,
            	      							"org.eclipse.gef.dot.internal.language.Dot.Attribute");
            	      						afterParserOrEnumRuleCall();
            	      					
            	    }

            	    }


            	    }

            	    // InternalDotParser.g:499:4: (otherlv_3= Comma | otherlv_4= Semicolon )?
            	    int alt11=3;
            	    int LA11_0 = input.LA(1);

            	    if ( (LA11_0==Comma) ) {
            	        alt11=1;
            	    }
            	    else if ( (LA11_0==Semicolon) ) {
            	        alt11=2;
            	    }
            	    switch (alt11) {
            	        case 1 :
            	            // InternalDotParser.g:500:5: otherlv_3= Comma
            	            {
            	            otherlv_3=(Token)match(input,Comma,FOLLOW_13); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              					newLeafNode(otherlv_3, grammarAccess.getAttrListAccess().getCommaKeyword_2_1_0());
            	              				
            	            }

            	            }
            	            break;
            	        case 2 :
            	            // InternalDotParser.g:505:5: otherlv_4= Semicolon
            	            {
            	            otherlv_4=(Token)match(input,Semicolon,FOLLOW_13); if (state.failed) return current;
            	            if ( state.backtracking==0 ) {

            	              					newLeafNode(otherlv_4, grammarAccess.getAttrListAccess().getSemicolonKeyword_2_1_1());
            	              				
            	            }

            	            }
            	            break;

            	    }


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

            otherlv_5=(Token)match(input,RightSquareBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_5, grammarAccess.getAttrListAccess().getRightSquareBracketKeyword_3());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAttrList"


    // $ANTLR start "entryRuleAttribute"
    // InternalDotParser.g:519:1: entryRuleAttribute returns [EObject current=null] : iv_ruleAttribute= ruleAttribute EOF ;
    public final EObject entryRuleAttribute() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAttribute = null;


        try {
            // InternalDotParser.g:519:50: (iv_ruleAttribute= ruleAttribute EOF )
            // InternalDotParser.g:520:2: iv_ruleAttribute= ruleAttribute EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getAttributeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleAttribute=ruleAttribute();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleAttribute; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAttribute"


    // $ANTLR start "ruleAttribute"
    // InternalDotParser.g:526:1: ruleAttribute returns [EObject current=null] : ( ( (lv_name_0_0= ruleID ) ) otherlv_1= EqualsSign ( (lv_value_2_0= ruleID ) ) ) ;
    public final EObject ruleAttribute() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        AntlrDatatypeRuleToken lv_name_0_0 = null;

        AntlrDatatypeRuleToken lv_value_2_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:532:2: ( ( ( (lv_name_0_0= ruleID ) ) otherlv_1= EqualsSign ( (lv_value_2_0= ruleID ) ) ) )
            // InternalDotParser.g:533:2: ( ( (lv_name_0_0= ruleID ) ) otherlv_1= EqualsSign ( (lv_value_2_0= ruleID ) ) )
            {
            // InternalDotParser.g:533:2: ( ( (lv_name_0_0= ruleID ) ) otherlv_1= EqualsSign ( (lv_value_2_0= ruleID ) ) )
            // InternalDotParser.g:534:3: ( (lv_name_0_0= ruleID ) ) otherlv_1= EqualsSign ( (lv_value_2_0= ruleID ) )
            {
            // InternalDotParser.g:534:3: ( (lv_name_0_0= ruleID ) )
            // InternalDotParser.g:535:4: (lv_name_0_0= ruleID )
            {
            // InternalDotParser.g:535:4: (lv_name_0_0= ruleID )
            // InternalDotParser.g:536:5: lv_name_0_0= ruleID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getAttributeAccess().getNameIDParserRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_15);
            lv_name_0_0=ruleID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getAttributeRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_0_0,
              						"org.eclipse.gef.dot.internal.language.Dot.ID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_1=(Token)match(input,EqualsSign,FOLLOW_16); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getAttributeAccess().getEqualsSignKeyword_1());
              		
            }
            // InternalDotParser.g:557:3: ( (lv_value_2_0= ruleID ) )
            // InternalDotParser.g:558:4: (lv_value_2_0= ruleID )
            {
            // InternalDotParser.g:558:4: (lv_value_2_0= ruleID )
            // InternalDotParser.g:559:5: lv_value_2_0= ruleID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getAttributeAccess().getValueIDParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_value_2_0=ruleID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getAttributeRule());
              					}
              					set(
              						current,
              						"value",
              						lv_value_2_0,
              						"org.eclipse.gef.dot.internal.language.Dot.ID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAttribute"


    // $ANTLR start "entryRuleSubgraphOrEdgeStmtSubgraph"
    // InternalDotParser.g:580:1: entryRuleSubgraphOrEdgeStmtSubgraph returns [EObject current=null] : iv_ruleSubgraphOrEdgeStmtSubgraph= ruleSubgraphOrEdgeStmtSubgraph EOF ;
    public final EObject entryRuleSubgraphOrEdgeStmtSubgraph() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSubgraphOrEdgeStmtSubgraph = null;


        try {
            // InternalDotParser.g:580:67: (iv_ruleSubgraphOrEdgeStmtSubgraph= ruleSubgraphOrEdgeStmtSubgraph EOF )
            // InternalDotParser.g:581:2: iv_ruleSubgraphOrEdgeStmtSubgraph= ruleSubgraphOrEdgeStmtSubgraph EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getSubgraphOrEdgeStmtSubgraphRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleSubgraphOrEdgeStmtSubgraph=ruleSubgraphOrEdgeStmtSubgraph();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleSubgraphOrEdgeStmtSubgraph; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSubgraphOrEdgeStmtSubgraph"


    // $ANTLR start "ruleSubgraphOrEdgeStmtSubgraph"
    // InternalDotParser.g:587:1: ruleSubgraphOrEdgeStmtSubgraph returns [EObject current=null] : (this_Subgraph_0= ruleSubgraph ( () ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+ ( (lv_attrLists_3_0= ruleAttrList ) )* )? ) ;
    public final EObject ruleSubgraphOrEdgeStmtSubgraph() throws RecognitionException {
        EObject current = null;

        EObject this_Subgraph_0 = null;

        EObject lv_edgeRHS_2_0 = null;

        EObject lv_attrLists_3_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:593:2: ( (this_Subgraph_0= ruleSubgraph ( () ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+ ( (lv_attrLists_3_0= ruleAttrList ) )* )? ) )
            // InternalDotParser.g:594:2: (this_Subgraph_0= ruleSubgraph ( () ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+ ( (lv_attrLists_3_0= ruleAttrList ) )* )? )
            {
            // InternalDotParser.g:594:2: (this_Subgraph_0= ruleSubgraph ( () ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+ ( (lv_attrLists_3_0= ruleAttrList ) )* )? )
            // InternalDotParser.g:595:3: this_Subgraph_0= ruleSubgraph ( () ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+ ( (lv_attrLists_3_0= ruleAttrList ) )* )?
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getSubgraphOrEdgeStmtSubgraphAccess().getSubgraphParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_17);
            this_Subgraph_0=ruleSubgraph();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current = this_Subgraph_0;
              			afterParserOrEnumRuleCall();
              		
            }
            // InternalDotParser.g:603:3: ( () ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+ ( (lv_attrLists_3_0= ruleAttrList ) )* )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( ((LA15_0>=HyphenMinusHyphenMinus && LA15_0<=HyphenMinusGreaterThanSign)) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // InternalDotParser.g:604:4: () ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+ ( (lv_attrLists_3_0= ruleAttrList ) )*
                    {
                    // InternalDotParser.g:604:4: ()
                    // InternalDotParser.g:605:5: 
                    {
                    if ( state.backtracking==0 ) {

                      					current = forceCreateModelElementAndSet(
                      						grammarAccess.getSubgraphOrEdgeStmtSubgraphAccess().getEdgeStmtSubgraphSubgraphAction_1_0(),
                      						current);
                      				
                    }

                    }

                    // InternalDotParser.g:611:4: ( (lv_edgeRHS_2_0= ruleEdgeRhs ) )+
                    int cnt13=0;
                    loop13:
                    do {
                        int alt13=2;
                        int LA13_0 = input.LA(1);

                        if ( ((LA13_0>=HyphenMinusHyphenMinus && LA13_0<=HyphenMinusGreaterThanSign)) ) {
                            alt13=1;
                        }


                        switch (alt13) {
                    	case 1 :
                    	    // InternalDotParser.g:612:5: (lv_edgeRHS_2_0= ruleEdgeRhs )
                    	    {
                    	    // InternalDotParser.g:612:5: (lv_edgeRHS_2_0= ruleEdgeRhs )
                    	    // InternalDotParser.g:613:6: lv_edgeRHS_2_0= ruleEdgeRhs
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getSubgraphOrEdgeStmtSubgraphAccess().getEdgeRHSEdgeRhsParserRuleCall_1_1_0());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_10);
                    	    lv_edgeRHS_2_0=ruleEdgeRhs();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						if (current==null) {
                    	      							current = createModelElementForParent(grammarAccess.getSubgraphOrEdgeStmtSubgraphRule());
                    	      						}
                    	      						add(
                    	      							current,
                    	      							"edgeRHS",
                    	      							lv_edgeRHS_2_0,
                    	      							"org.eclipse.gef.dot.internal.language.Dot.EdgeRhs");
                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt13 >= 1 ) break loop13;
                    	    if (state.backtracking>0) {state.failed=true; return current;}
                                EarlyExitException eee =
                                    new EarlyExitException(13, input);
                                throw eee;
                        }
                        cnt13++;
                    } while (true);

                    // InternalDotParser.g:630:4: ( (lv_attrLists_3_0= ruleAttrList ) )*
                    loop14:
                    do {
                        int alt14=2;
                        int LA14_0 = input.LA(1);

                        if ( (LA14_0==LeftSquareBracket) ) {
                            alt14=1;
                        }


                        switch (alt14) {
                    	case 1 :
                    	    // InternalDotParser.g:631:5: (lv_attrLists_3_0= ruleAttrList )
                    	    {
                    	    // InternalDotParser.g:631:5: (lv_attrLists_3_0= ruleAttrList )
                    	    // InternalDotParser.g:632:6: lv_attrLists_3_0= ruleAttrList
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getSubgraphOrEdgeStmtSubgraphAccess().getAttrListsAttrListParserRuleCall_1_2_0());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_11);
                    	    lv_attrLists_3_0=ruleAttrList();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						if (current==null) {
                    	      							current = createModelElementForParent(grammarAccess.getSubgraphOrEdgeStmtSubgraphRule());
                    	      						}
                    	      						add(
                    	      							current,
                    	      							"attrLists",
                    	      							lv_attrLists_3_0,
                    	      							"org.eclipse.gef.dot.internal.language.Dot.AttrList");
                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop14;
                        }
                    } while (true);


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSubgraphOrEdgeStmtSubgraph"


    // $ANTLR start "entryRuleSubgraph"
    // InternalDotParser.g:654:1: entryRuleSubgraph returns [EObject current=null] : iv_ruleSubgraph= ruleSubgraph EOF ;
    public final EObject entryRuleSubgraph() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSubgraph = null;


        try {
            // InternalDotParser.g:654:49: (iv_ruleSubgraph= ruleSubgraph EOF )
            // InternalDotParser.g:655:2: iv_ruleSubgraph= ruleSubgraph EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getSubgraphRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleSubgraph=ruleSubgraph();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleSubgraph; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSubgraph"


    // $ANTLR start "ruleSubgraph"
    // InternalDotParser.g:661:1: ruleSubgraph returns [EObject current=null] : ( () (otherlv_1= Subgraph ( (lv_name_2_0= ruleID ) )? )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket ) ;
    public final EObject ruleSubgraph() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        AntlrDatatypeRuleToken lv_name_2_0 = null;

        EObject lv_stmts_4_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:667:2: ( ( () (otherlv_1= Subgraph ( (lv_name_2_0= ruleID ) )? )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket ) )
            // InternalDotParser.g:668:2: ( () (otherlv_1= Subgraph ( (lv_name_2_0= ruleID ) )? )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket )
            {
            // InternalDotParser.g:668:2: ( () (otherlv_1= Subgraph ( (lv_name_2_0= ruleID ) )? )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket )
            // InternalDotParser.g:669:3: () (otherlv_1= Subgraph ( (lv_name_2_0= ruleID ) )? )? otherlv_3= LeftCurlyBracket ( (lv_stmts_4_0= ruleStmt ) )* otherlv_5= RightCurlyBracket
            {
            // InternalDotParser.g:669:3: ()
            // InternalDotParser.g:670:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getSubgraphAccess().getSubgraphAction_0(),
              					current);
              			
            }

            }

            // InternalDotParser.g:676:3: (otherlv_1= Subgraph ( (lv_name_2_0= ruleID ) )? )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==Subgraph) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // InternalDotParser.g:677:4: otherlv_1= Subgraph ( (lv_name_2_0= ruleID ) )?
                    {
                    otherlv_1=(Token)match(input,Subgraph,FOLLOW_5); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_1, grammarAccess.getSubgraphAccess().getSubgraphKeyword_1_0());
                      			
                    }
                    // InternalDotParser.g:681:4: ( (lv_name_2_0= ruleID ) )?
                    int alt16=2;
                    int LA16_0 = input.LA(1);

                    if ( ((LA16_0>=RULE_NUMERAL && LA16_0<=RULE_QUOTED_STRING)||LA16_0==RULE_HTML_STRING) ) {
                        alt16=1;
                    }
                    switch (alt16) {
                        case 1 :
                            // InternalDotParser.g:682:5: (lv_name_2_0= ruleID )
                            {
                            // InternalDotParser.g:682:5: (lv_name_2_0= ruleID )
                            // InternalDotParser.g:683:6: lv_name_2_0= ruleID
                            {
                            if ( state.backtracking==0 ) {

                              						newCompositeNode(grammarAccess.getSubgraphAccess().getNameIDParserRuleCall_1_1_0());
                              					
                            }
                            pushFollow(FOLLOW_6);
                            lv_name_2_0=ruleID();

                            state._fsp--;
                            if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						if (current==null) {
                              							current = createModelElementForParent(grammarAccess.getSubgraphRule());
                              						}
                              						set(
                              							current,
                              							"name",
                              							lv_name_2_0,
                              							"org.eclipse.gef.dot.internal.language.Dot.ID");
                              						afterParserOrEnumRuleCall();
                              					
                            }

                            }


                            }
                            break;

                    }


                    }
                    break;

            }

            otherlv_3=(Token)match(input,LeftCurlyBracket,FOLLOW_7); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getSubgraphAccess().getLeftCurlyBracketKeyword_2());
              		
            }
            // InternalDotParser.g:705:3: ( (lv_stmts_4_0= ruleStmt ) )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0==Subgraph||(LA18_0>=Graph && LA18_0<=Node)||LA18_0==LeftCurlyBracket||(LA18_0>=RULE_NUMERAL && LA18_0<=RULE_QUOTED_STRING)||LA18_0==RULE_HTML_STRING) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // InternalDotParser.g:706:4: (lv_stmts_4_0= ruleStmt )
            	    {
            	    // InternalDotParser.g:706:4: (lv_stmts_4_0= ruleStmt )
            	    // InternalDotParser.g:707:5: lv_stmts_4_0= ruleStmt
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getSubgraphAccess().getStmtsStmtParserRuleCall_3_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_7);
            	    lv_stmts_4_0=ruleStmt();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getSubgraphRule());
            	      					}
            	      					add(
            	      						current,
            	      						"stmts",
            	      						lv_stmts_4_0,
            	      						"org.eclipse.gef.dot.internal.language.Dot.Stmt");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);

            otherlv_5=(Token)match(input,RightCurlyBracket,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_5, grammarAccess.getSubgraphAccess().getRightCurlyBracketKeyword_4());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSubgraph"


    // $ANTLR start "entryRulePort"
    // InternalDotParser.g:732:1: entryRulePort returns [EObject current=null] : iv_rulePort= rulePort EOF ;
    public final EObject entryRulePort() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePort = null;


        try {
            // InternalDotParser.g:732:45: (iv_rulePort= rulePort EOF )
            // InternalDotParser.g:733:2: iv_rulePort= rulePort EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getPortRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_rulePort=rulePort();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_rulePort; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePort"


    // $ANTLR start "rulePort"
    // InternalDotParser.g:739:1: rulePort returns [EObject current=null] : (otherlv_0= Colon ( ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) ) | ( (lv_name_2_0= ruleID ) ) | ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) ) ) ) ;
    public final EObject rulePort() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_compass_pt_1_0=null;
        Token otherlv_4=null;
        Token lv_compass_pt_5_0=null;
        AntlrDatatypeRuleToken lv_name_2_0 = null;

        AntlrDatatypeRuleToken lv_name_3_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:745:2: ( (otherlv_0= Colon ( ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) ) | ( (lv_name_2_0= ruleID ) ) | ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) ) ) ) )
            // InternalDotParser.g:746:2: (otherlv_0= Colon ( ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) ) | ( (lv_name_2_0= ruleID ) ) | ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) ) ) )
            {
            // InternalDotParser.g:746:2: (otherlv_0= Colon ( ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) ) | ( (lv_name_2_0= ruleID ) ) | ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) ) ) )
            // InternalDotParser.g:747:3: otherlv_0= Colon ( ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) ) | ( (lv_name_2_0= ruleID ) ) | ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) ) )
            {
            otherlv_0=(Token)match(input,Colon,FOLLOW_16); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getPortAccess().getColonKeyword_0());
              		
            }
            // InternalDotParser.g:751:3: ( ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) ) | ( (lv_name_2_0= ruleID ) ) | ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) ) )
            int alt19=3;
            switch ( input.LA(1) ) {
            case RULE_COMPASS_PT:
                {
                int LA19_1 = input.LA(2);

                if ( (LA19_1==Colon) ) {
                    alt19=3;
                }
                else if ( (synpred1_InternalDotParser()) ) {
                    alt19=1;
                }
                else if ( (true) ) {
                    alt19=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 19, 1, input);

                    throw nvae;
                }
                }
                break;
            case RULE_NUMERAL:
                {
                int LA19_2 = input.LA(2);

                if ( (LA19_2==EOF||LA19_2==Subgraph||(LA19_2>=Graph && LA19_2<=HyphenMinusGreaterThanSign)||LA19_2==Semicolon||LA19_2==LeftSquareBracket||(LA19_2>=LeftCurlyBracket && LA19_2<=RULE_QUOTED_STRING)||LA19_2==RULE_HTML_STRING) ) {
                    alt19=2;
                }
                else if ( (LA19_2==Colon) ) {
                    alt19=3;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 19, 2, input);

                    throw nvae;
                }
                }
                break;
            case RULE_STRING:
                {
                int LA19_3 = input.LA(2);

                if ( (LA19_3==EOF||LA19_3==Subgraph||(LA19_3>=Graph && LA19_3<=HyphenMinusGreaterThanSign)||LA19_3==Semicolon||LA19_3==LeftSquareBracket||(LA19_3>=LeftCurlyBracket && LA19_3<=RULE_QUOTED_STRING)||LA19_3==RULE_HTML_STRING) ) {
                    alt19=2;
                }
                else if ( (LA19_3==Colon) ) {
                    alt19=3;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 19, 3, input);

                    throw nvae;
                }
                }
                break;
            case RULE_QUOTED_STRING:
                {
                int LA19_4 = input.LA(2);

                if ( (LA19_4==Colon) ) {
                    alt19=3;
                }
                else if ( (LA19_4==EOF||LA19_4==Subgraph||(LA19_4>=Graph && LA19_4<=HyphenMinusGreaterThanSign)||LA19_4==Semicolon||LA19_4==LeftSquareBracket||(LA19_4>=LeftCurlyBracket && LA19_4<=RULE_QUOTED_STRING)||LA19_4==RULE_HTML_STRING) ) {
                    alt19=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 19, 4, input);

                    throw nvae;
                }
                }
                break;
            case RULE_HTML_STRING:
                {
                int LA19_5 = input.LA(2);

                if ( (LA19_5==Colon) ) {
                    alt19=3;
                }
                else if ( (LA19_5==EOF||LA19_5==Subgraph||(LA19_5>=Graph && LA19_5<=HyphenMinusGreaterThanSign)||LA19_5==Semicolon||LA19_5==LeftSquareBracket||(LA19_5>=LeftCurlyBracket && LA19_5<=RULE_QUOTED_STRING)||LA19_5==RULE_HTML_STRING) ) {
                    alt19=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 19, 5, input);

                    throw nvae;
                }
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;
            }

            switch (alt19) {
                case 1 :
                    // InternalDotParser.g:752:4: ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) )
                    {
                    // InternalDotParser.g:752:4: ( ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT ) )
                    // InternalDotParser.g:753:5: ( ( RULE_COMPASS_PT ) )=> (lv_compass_pt_1_0= RULE_COMPASS_PT )
                    {
                    // InternalDotParser.g:757:5: (lv_compass_pt_1_0= RULE_COMPASS_PT )
                    // InternalDotParser.g:758:6: lv_compass_pt_1_0= RULE_COMPASS_PT
                    {
                    lv_compass_pt_1_0=(Token)match(input,RULE_COMPASS_PT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						newLeafNode(lv_compass_pt_1_0, grammarAccess.getPortAccess().getCompass_ptCOMPASS_PTTerminalRuleCall_1_0_0());
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getPortRule());
                      						}
                      						setWithLastConsumed(
                      							current,
                      							"compass_pt",
                      							lv_compass_pt_1_0,
                      							"org.eclipse.gef.dot.internal.language.Dot.COMPASS_PT");
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalDotParser.g:775:4: ( (lv_name_2_0= ruleID ) )
                    {
                    // InternalDotParser.g:775:4: ( (lv_name_2_0= ruleID ) )
                    // InternalDotParser.g:776:5: (lv_name_2_0= ruleID )
                    {
                    // InternalDotParser.g:776:5: (lv_name_2_0= ruleID )
                    // InternalDotParser.g:777:6: lv_name_2_0= ruleID
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getPortAccess().getNameIDParserRuleCall_1_1_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_name_2_0=ruleID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getPortRule());
                      						}
                      						set(
                      							current,
                      							"name",
                      							lv_name_2_0,
                      							"org.eclipse.gef.dot.internal.language.Dot.ID");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 3 :
                    // InternalDotParser.g:795:4: ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) )
                    {
                    // InternalDotParser.g:795:4: ( ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) ) )
                    // InternalDotParser.g:796:5: ( (lv_name_3_0= ruleID ) ) otherlv_4= Colon ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) )
                    {
                    // InternalDotParser.g:796:5: ( (lv_name_3_0= ruleID ) )
                    // InternalDotParser.g:797:6: (lv_name_3_0= ruleID )
                    {
                    // InternalDotParser.g:797:6: (lv_name_3_0= ruleID )
                    // InternalDotParser.g:798:7: lv_name_3_0= ruleID
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getPortAccess().getNameIDParserRuleCall_1_2_0_0());
                      						
                    }
                    pushFollow(FOLLOW_18);
                    lv_name_3_0=ruleID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getPortRule());
                      							}
                      							set(
                      								current,
                      								"name",
                      								lv_name_3_0,
                      								"org.eclipse.gef.dot.internal.language.Dot.ID");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    otherlv_4=(Token)match(input,Colon,FOLLOW_19); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_4, grammarAccess.getPortAccess().getColonKeyword_1_2_1());
                      				
                    }
                    // InternalDotParser.g:819:5: ( (lv_compass_pt_5_0= RULE_COMPASS_PT ) )
                    // InternalDotParser.g:820:6: (lv_compass_pt_5_0= RULE_COMPASS_PT )
                    {
                    // InternalDotParser.g:820:6: (lv_compass_pt_5_0= RULE_COMPASS_PT )
                    // InternalDotParser.g:821:7: lv_compass_pt_5_0= RULE_COMPASS_PT
                    {
                    lv_compass_pt_5_0=(Token)match(input,RULE_COMPASS_PT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							newLeafNode(lv_compass_pt_5_0, grammarAccess.getPortAccess().getCompass_ptCOMPASS_PTTerminalRuleCall_1_2_2_0());
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getPortRule());
                      							}
                      							setWithLastConsumed(
                      								current,
                      								"compass_pt",
                      								lv_compass_pt_5_0,
                      								"org.eclipse.gef.dot.internal.language.Dot.COMPASS_PT");
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePort"


    // $ANTLR start "entryRuleEdgeRhs"
    // InternalDotParser.g:843:1: entryRuleEdgeRhs returns [EObject current=null] : iv_ruleEdgeRhs= ruleEdgeRhs EOF ;
    public final EObject entryRuleEdgeRhs() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEdgeRhs = null;


        try {
            // InternalDotParser.g:843:48: (iv_ruleEdgeRhs= ruleEdgeRhs EOF )
            // InternalDotParser.g:844:2: iv_ruleEdgeRhs= ruleEdgeRhs EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEdgeRhsRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEdgeRhs=ruleEdgeRhs();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEdgeRhs; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEdgeRhs"


    // $ANTLR start "ruleEdgeRhs"
    // InternalDotParser.g:850:1: ruleEdgeRhs returns [EObject current=null] : (this_EdgeRhsNode_0= ruleEdgeRhsNode | this_EdgeRhsSubgraph_1= ruleEdgeRhsSubgraph ) ;
    public final EObject ruleEdgeRhs() throws RecognitionException {
        EObject current = null;

        EObject this_EdgeRhsNode_0 = null;

        EObject this_EdgeRhsSubgraph_1 = null;



        	enterRule();

        try {
            // InternalDotParser.g:856:2: ( (this_EdgeRhsNode_0= ruleEdgeRhsNode | this_EdgeRhsSubgraph_1= ruleEdgeRhsSubgraph ) )
            // InternalDotParser.g:857:2: (this_EdgeRhsNode_0= ruleEdgeRhsNode | this_EdgeRhsSubgraph_1= ruleEdgeRhsSubgraph )
            {
            // InternalDotParser.g:857:2: (this_EdgeRhsNode_0= ruleEdgeRhsNode | this_EdgeRhsSubgraph_1= ruleEdgeRhsSubgraph )
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==HyphenMinusGreaterThanSign) ) {
                int LA20_1 = input.LA(2);

                if ( ((LA20_1>=RULE_NUMERAL && LA20_1<=RULE_QUOTED_STRING)||LA20_1==RULE_HTML_STRING) ) {
                    alt20=1;
                }
                else if ( (LA20_1==Subgraph||LA20_1==LeftCurlyBracket) ) {
                    alt20=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 20, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA20_0==HyphenMinusHyphenMinus) ) {
                int LA20_2 = input.LA(2);

                if ( (LA20_2==Subgraph||LA20_2==LeftCurlyBracket) ) {
                    alt20=2;
                }
                else if ( ((LA20_2>=RULE_NUMERAL && LA20_2<=RULE_QUOTED_STRING)||LA20_2==RULE_HTML_STRING) ) {
                    alt20=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 20, 2, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }
            switch (alt20) {
                case 1 :
                    // InternalDotParser.g:858:3: this_EdgeRhsNode_0= ruleEdgeRhsNode
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getEdgeRhsAccess().getEdgeRhsNodeParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_EdgeRhsNode_0=ruleEdgeRhsNode();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_EdgeRhsNode_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalDotParser.g:867:3: this_EdgeRhsSubgraph_1= ruleEdgeRhsSubgraph
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getEdgeRhsAccess().getEdgeRhsSubgraphParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_EdgeRhsSubgraph_1=ruleEdgeRhsSubgraph();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_EdgeRhsSubgraph_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEdgeRhs"


    // $ANTLR start "entryRuleEdgeRhsNode"
    // InternalDotParser.g:879:1: entryRuleEdgeRhsNode returns [EObject current=null] : iv_ruleEdgeRhsNode= ruleEdgeRhsNode EOF ;
    public final EObject entryRuleEdgeRhsNode() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEdgeRhsNode = null;


        try {
            // InternalDotParser.g:879:52: (iv_ruleEdgeRhsNode= ruleEdgeRhsNode EOF )
            // InternalDotParser.g:880:2: iv_ruleEdgeRhsNode= ruleEdgeRhsNode EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEdgeRhsNodeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEdgeRhsNode=ruleEdgeRhsNode();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEdgeRhsNode; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEdgeRhsNode"


    // $ANTLR start "ruleEdgeRhsNode"
    // InternalDotParser.g:886:1: ruleEdgeRhsNode returns [EObject current=null] : ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_node_1_0= ruleNodeId ) ) ) ;
    public final EObject ruleEdgeRhsNode() throws RecognitionException {
        EObject current = null;

        Enumerator lv_op_0_0 = null;

        EObject lv_node_1_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:892:2: ( ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_node_1_0= ruleNodeId ) ) ) )
            // InternalDotParser.g:893:2: ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_node_1_0= ruleNodeId ) ) )
            {
            // InternalDotParser.g:893:2: ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_node_1_0= ruleNodeId ) ) )
            // InternalDotParser.g:894:3: ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_node_1_0= ruleNodeId ) )
            {
            // InternalDotParser.g:894:3: ( (lv_op_0_0= ruleEdgeOp ) )
            // InternalDotParser.g:895:4: (lv_op_0_0= ruleEdgeOp )
            {
            // InternalDotParser.g:895:4: (lv_op_0_0= ruleEdgeOp )
            // InternalDotParser.g:896:5: lv_op_0_0= ruleEdgeOp
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getEdgeRhsNodeAccess().getOpEdgeOpEnumRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_16);
            lv_op_0_0=ruleEdgeOp();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getEdgeRhsNodeRule());
              					}
              					set(
              						current,
              						"op",
              						lv_op_0_0,
              						"org.eclipse.gef.dot.internal.language.Dot.EdgeOp");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDotParser.g:913:3: ( (lv_node_1_0= ruleNodeId ) )
            // InternalDotParser.g:914:4: (lv_node_1_0= ruleNodeId )
            {
            // InternalDotParser.g:914:4: (lv_node_1_0= ruleNodeId )
            // InternalDotParser.g:915:5: lv_node_1_0= ruleNodeId
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getEdgeRhsNodeAccess().getNodeNodeIdParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_node_1_0=ruleNodeId();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getEdgeRhsNodeRule());
              					}
              					set(
              						current,
              						"node",
              						lv_node_1_0,
              						"org.eclipse.gef.dot.internal.language.Dot.NodeId");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEdgeRhsNode"


    // $ANTLR start "entryRuleEdgeRhsSubgraph"
    // InternalDotParser.g:936:1: entryRuleEdgeRhsSubgraph returns [EObject current=null] : iv_ruleEdgeRhsSubgraph= ruleEdgeRhsSubgraph EOF ;
    public final EObject entryRuleEdgeRhsSubgraph() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEdgeRhsSubgraph = null;


        try {
            // InternalDotParser.g:936:56: (iv_ruleEdgeRhsSubgraph= ruleEdgeRhsSubgraph EOF )
            // InternalDotParser.g:937:2: iv_ruleEdgeRhsSubgraph= ruleEdgeRhsSubgraph EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEdgeRhsSubgraphRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEdgeRhsSubgraph=ruleEdgeRhsSubgraph();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEdgeRhsSubgraph; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEdgeRhsSubgraph"


    // $ANTLR start "ruleEdgeRhsSubgraph"
    // InternalDotParser.g:943:1: ruleEdgeRhsSubgraph returns [EObject current=null] : ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_subgraph_1_0= ruleSubgraph ) ) ) ;
    public final EObject ruleEdgeRhsSubgraph() throws RecognitionException {
        EObject current = null;

        Enumerator lv_op_0_0 = null;

        EObject lv_subgraph_1_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:949:2: ( ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_subgraph_1_0= ruleSubgraph ) ) ) )
            // InternalDotParser.g:950:2: ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_subgraph_1_0= ruleSubgraph ) ) )
            {
            // InternalDotParser.g:950:2: ( ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_subgraph_1_0= ruleSubgraph ) ) )
            // InternalDotParser.g:951:3: ( (lv_op_0_0= ruleEdgeOp ) ) ( (lv_subgraph_1_0= ruleSubgraph ) )
            {
            // InternalDotParser.g:951:3: ( (lv_op_0_0= ruleEdgeOp ) )
            // InternalDotParser.g:952:4: (lv_op_0_0= ruleEdgeOp )
            {
            // InternalDotParser.g:952:4: (lv_op_0_0= ruleEdgeOp )
            // InternalDotParser.g:953:5: lv_op_0_0= ruleEdgeOp
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getEdgeRhsSubgraphAccess().getOpEdgeOpEnumRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_20);
            lv_op_0_0=ruleEdgeOp();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getEdgeRhsSubgraphRule());
              					}
              					set(
              						current,
              						"op",
              						lv_op_0_0,
              						"org.eclipse.gef.dot.internal.language.Dot.EdgeOp");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDotParser.g:970:3: ( (lv_subgraph_1_0= ruleSubgraph ) )
            // InternalDotParser.g:971:4: (lv_subgraph_1_0= ruleSubgraph )
            {
            // InternalDotParser.g:971:4: (lv_subgraph_1_0= ruleSubgraph )
            // InternalDotParser.g:972:5: lv_subgraph_1_0= ruleSubgraph
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getEdgeRhsSubgraphAccess().getSubgraphSubgraphParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_subgraph_1_0=ruleSubgraph();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getEdgeRhsSubgraphRule());
              					}
              					set(
              						current,
              						"subgraph",
              						lv_subgraph_1_0,
              						"org.eclipse.gef.dot.internal.language.Dot.Subgraph");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEdgeRhsSubgraph"


    // $ANTLR start "entryRuleNodeId"
    // InternalDotParser.g:993:1: entryRuleNodeId returns [EObject current=null] : iv_ruleNodeId= ruleNodeId EOF ;
    public final EObject entryRuleNodeId() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleNodeId = null;


        try {
            // InternalDotParser.g:993:47: (iv_ruleNodeId= ruleNodeId EOF )
            // InternalDotParser.g:994:2: iv_ruleNodeId= ruleNodeId EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getNodeIdRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleNodeId=ruleNodeId();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleNodeId; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleNodeId"


    // $ANTLR start "ruleNodeId"
    // InternalDotParser.g:1000:1: ruleNodeId returns [EObject current=null] : ( ( (lv_name_0_0= ruleID ) ) ( (lv_port_1_0= rulePort ) )? ) ;
    public final EObject ruleNodeId() throws RecognitionException {
        EObject current = null;

        AntlrDatatypeRuleToken lv_name_0_0 = null;

        EObject lv_port_1_0 = null;



        	enterRule();

        try {
            // InternalDotParser.g:1006:2: ( ( ( (lv_name_0_0= ruleID ) ) ( (lv_port_1_0= rulePort ) )? ) )
            // InternalDotParser.g:1007:2: ( ( (lv_name_0_0= ruleID ) ) ( (lv_port_1_0= rulePort ) )? )
            {
            // InternalDotParser.g:1007:2: ( ( (lv_name_0_0= ruleID ) ) ( (lv_port_1_0= rulePort ) )? )
            // InternalDotParser.g:1008:3: ( (lv_name_0_0= ruleID ) ) ( (lv_port_1_0= rulePort ) )?
            {
            // InternalDotParser.g:1008:3: ( (lv_name_0_0= ruleID ) )
            // InternalDotParser.g:1009:4: (lv_name_0_0= ruleID )
            {
            // InternalDotParser.g:1009:4: (lv_name_0_0= ruleID )
            // InternalDotParser.g:1010:5: lv_name_0_0= ruleID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getNodeIdAccess().getNameIDParserRuleCall_0_0());
              				
            }
            pushFollow(FOLLOW_21);
            lv_name_0_0=ruleID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getNodeIdRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_0_0,
              						"org.eclipse.gef.dot.internal.language.Dot.ID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalDotParser.g:1027:3: ( (lv_port_1_0= rulePort ) )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==Colon) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // InternalDotParser.g:1028:4: (lv_port_1_0= rulePort )
                    {
                    // InternalDotParser.g:1028:4: (lv_port_1_0= rulePort )
                    // InternalDotParser.g:1029:5: lv_port_1_0= rulePort
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getNodeIdAccess().getPortPortParserRuleCall_1_0());
                      				
                    }
                    pushFollow(FOLLOW_2);
                    lv_port_1_0=rulePort();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getNodeIdRule());
                      					}
                      					set(
                      						current,
                      						"port",
                      						lv_port_1_0,
                      						"org.eclipse.gef.dot.internal.language.Dot.Port");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleNodeId"


    // $ANTLR start "entryRuleID"
    // InternalDotParser.g:1050:1: entryRuleID returns [String current=null] : iv_ruleID= ruleID EOF ;
    public final String entryRuleID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleID = null;


        try {
            // InternalDotParser.g:1050:42: (iv_ruleID= ruleID EOF )
            // InternalDotParser.g:1051:2: iv_ruleID= ruleID EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getIDRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleID=ruleID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleID.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleID"


    // $ANTLR start "ruleID"
    // InternalDotParser.g:1057:1: ruleID returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_NUMERAL_0= RULE_NUMERAL | this_COMPASS_PT_1= RULE_COMPASS_PT | this_STRING_2= RULE_STRING | this_QUOTED_STRING_3= RULE_QUOTED_STRING | this_HTML_STRING_4= RULE_HTML_STRING ) ;
    public final AntlrDatatypeRuleToken ruleID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_NUMERAL_0=null;
        Token this_COMPASS_PT_1=null;
        Token this_STRING_2=null;
        Token this_QUOTED_STRING_3=null;
        Token this_HTML_STRING_4=null;


        	enterRule();

        try {
            // InternalDotParser.g:1063:2: ( (this_NUMERAL_0= RULE_NUMERAL | this_COMPASS_PT_1= RULE_COMPASS_PT | this_STRING_2= RULE_STRING | this_QUOTED_STRING_3= RULE_QUOTED_STRING | this_HTML_STRING_4= RULE_HTML_STRING ) )
            // InternalDotParser.g:1064:2: (this_NUMERAL_0= RULE_NUMERAL | this_COMPASS_PT_1= RULE_COMPASS_PT | this_STRING_2= RULE_STRING | this_QUOTED_STRING_3= RULE_QUOTED_STRING | this_HTML_STRING_4= RULE_HTML_STRING )
            {
            // InternalDotParser.g:1064:2: (this_NUMERAL_0= RULE_NUMERAL | this_COMPASS_PT_1= RULE_COMPASS_PT | this_STRING_2= RULE_STRING | this_QUOTED_STRING_3= RULE_QUOTED_STRING | this_HTML_STRING_4= RULE_HTML_STRING )
            int alt22=5;
            switch ( input.LA(1) ) {
            case RULE_NUMERAL:
                {
                alt22=1;
                }
                break;
            case RULE_COMPASS_PT:
                {
                alt22=2;
                }
                break;
            case RULE_STRING:
                {
                alt22=3;
                }
                break;
            case RULE_QUOTED_STRING:
                {
                alt22=4;
                }
                break;
            case RULE_HTML_STRING:
                {
                alt22=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 22, 0, input);

                throw nvae;
            }

            switch (alt22) {
                case 1 :
                    // InternalDotParser.g:1065:3: this_NUMERAL_0= RULE_NUMERAL
                    {
                    this_NUMERAL_0=(Token)match(input,RULE_NUMERAL,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_NUMERAL_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_NUMERAL_0, grammarAccess.getIDAccess().getNUMERALTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalDotParser.g:1073:3: this_COMPASS_PT_1= RULE_COMPASS_PT
                    {
                    this_COMPASS_PT_1=(Token)match(input,RULE_COMPASS_PT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_COMPASS_PT_1);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_COMPASS_PT_1, grammarAccess.getIDAccess().getCOMPASS_PTTerminalRuleCall_1());
                      		
                    }

                    }
                    break;
                case 3 :
                    // InternalDotParser.g:1081:3: this_STRING_2= RULE_STRING
                    {
                    this_STRING_2=(Token)match(input,RULE_STRING,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_STRING_2);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_STRING_2, grammarAccess.getIDAccess().getSTRINGTerminalRuleCall_2());
                      		
                    }

                    }
                    break;
                case 4 :
                    // InternalDotParser.g:1089:3: this_QUOTED_STRING_3= RULE_QUOTED_STRING
                    {
                    this_QUOTED_STRING_3=(Token)match(input,RULE_QUOTED_STRING,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_QUOTED_STRING_3);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_QUOTED_STRING_3, grammarAccess.getIDAccess().getQUOTED_STRINGTerminalRuleCall_3());
                      		
                    }

                    }
                    break;
                case 5 :
                    // InternalDotParser.g:1097:3: this_HTML_STRING_4= RULE_HTML_STRING
                    {
                    this_HTML_STRING_4=(Token)match(input,RULE_HTML_STRING,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_HTML_STRING_4);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_HTML_STRING_4, grammarAccess.getIDAccess().getHTML_STRINGTerminalRuleCall_4());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleID"


    // $ANTLR start "ruleEdgeOp"
    // InternalDotParser.g:1108:1: ruleEdgeOp returns [Enumerator current=null] : ( (enumLiteral_0= HyphenMinusGreaterThanSign ) | (enumLiteral_1= HyphenMinusHyphenMinus ) ) ;
    public final Enumerator ruleEdgeOp() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;


        	enterRule();

        try {
            // InternalDotParser.g:1114:2: ( ( (enumLiteral_0= HyphenMinusGreaterThanSign ) | (enumLiteral_1= HyphenMinusHyphenMinus ) ) )
            // InternalDotParser.g:1115:2: ( (enumLiteral_0= HyphenMinusGreaterThanSign ) | (enumLiteral_1= HyphenMinusHyphenMinus ) )
            {
            // InternalDotParser.g:1115:2: ( (enumLiteral_0= HyphenMinusGreaterThanSign ) | (enumLiteral_1= HyphenMinusHyphenMinus ) )
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==HyphenMinusGreaterThanSign) ) {
                alt23=1;
            }
            else if ( (LA23_0==HyphenMinusHyphenMinus) ) {
                alt23=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;
            }
            switch (alt23) {
                case 1 :
                    // InternalDotParser.g:1116:3: (enumLiteral_0= HyphenMinusGreaterThanSign )
                    {
                    // InternalDotParser.g:1116:3: (enumLiteral_0= HyphenMinusGreaterThanSign )
                    // InternalDotParser.g:1117:4: enumLiteral_0= HyphenMinusGreaterThanSign
                    {
                    enumLiteral_0=(Token)match(input,HyphenMinusGreaterThanSign,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getEdgeOpAccess().getDirectedEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_0, grammarAccess.getEdgeOpAccess().getDirectedEnumLiteralDeclaration_0());
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalDotParser.g:1124:3: (enumLiteral_1= HyphenMinusHyphenMinus )
                    {
                    // InternalDotParser.g:1124:3: (enumLiteral_1= HyphenMinusHyphenMinus )
                    // InternalDotParser.g:1125:4: enumLiteral_1= HyphenMinusHyphenMinus
                    {
                    enumLiteral_1=(Token)match(input,HyphenMinusHyphenMinus,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getEdgeOpAccess().getUndirectedEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_1, grammarAccess.getEdgeOpAccess().getUndirectedEnumLiteralDeclaration_1());
                      			
                    }

                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEdgeOp"


    // $ANTLR start "ruleGraphType"
    // InternalDotParser.g:1135:1: ruleGraphType returns [Enumerator current=null] : ( (enumLiteral_0= Graph ) | (enumLiteral_1= Digraph ) ) ;
    public final Enumerator ruleGraphType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;


        	enterRule();

        try {
            // InternalDotParser.g:1141:2: ( ( (enumLiteral_0= Graph ) | (enumLiteral_1= Digraph ) ) )
            // InternalDotParser.g:1142:2: ( (enumLiteral_0= Graph ) | (enumLiteral_1= Digraph ) )
            {
            // InternalDotParser.g:1142:2: ( (enumLiteral_0= Graph ) | (enumLiteral_1= Digraph ) )
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==Graph) ) {
                alt24=1;
            }
            else if ( (LA24_0==Digraph) ) {
                alt24=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }
            switch (alt24) {
                case 1 :
                    // InternalDotParser.g:1143:3: (enumLiteral_0= Graph )
                    {
                    // InternalDotParser.g:1143:3: (enumLiteral_0= Graph )
                    // InternalDotParser.g:1144:4: enumLiteral_0= Graph
                    {
                    enumLiteral_0=(Token)match(input,Graph,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getGraphTypeAccess().getGraphEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_0, grammarAccess.getGraphTypeAccess().getGraphEnumLiteralDeclaration_0());
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalDotParser.g:1151:3: (enumLiteral_1= Digraph )
                    {
                    // InternalDotParser.g:1151:3: (enumLiteral_1= Digraph )
                    // InternalDotParser.g:1152:4: enumLiteral_1= Digraph
                    {
                    enumLiteral_1=(Token)match(input,Digraph,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getGraphTypeAccess().getDigraphEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_1, grammarAccess.getGraphTypeAccess().getDigraphEnumLiteralDeclaration_1());
                      			
                    }

                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGraphType"


    // $ANTLR start "ruleAttributeType"
    // InternalDotParser.g:1162:1: ruleAttributeType returns [Enumerator current=null] : ( (enumLiteral_0= Graph ) | (enumLiteral_1= Node ) | (enumLiteral_2= Edge ) ) ;
    public final Enumerator ruleAttributeType() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;


        	enterRule();

        try {
            // InternalDotParser.g:1168:2: ( ( (enumLiteral_0= Graph ) | (enumLiteral_1= Node ) | (enumLiteral_2= Edge ) ) )
            // InternalDotParser.g:1169:2: ( (enumLiteral_0= Graph ) | (enumLiteral_1= Node ) | (enumLiteral_2= Edge ) )
            {
            // InternalDotParser.g:1169:2: ( (enumLiteral_0= Graph ) | (enumLiteral_1= Node ) | (enumLiteral_2= Edge ) )
            int alt25=3;
            switch ( input.LA(1) ) {
            case Graph:
                {
                alt25=1;
                }
                break;
            case Node:
                {
                alt25=2;
                }
                break;
            case Edge:
                {
                alt25=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // InternalDotParser.g:1170:3: (enumLiteral_0= Graph )
                    {
                    // InternalDotParser.g:1170:3: (enumLiteral_0= Graph )
                    // InternalDotParser.g:1171:4: enumLiteral_0= Graph
                    {
                    enumLiteral_0=(Token)match(input,Graph,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getAttributeTypeAccess().getGraphEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_0, grammarAccess.getAttributeTypeAccess().getGraphEnumLiteralDeclaration_0());
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalDotParser.g:1178:3: (enumLiteral_1= Node )
                    {
                    // InternalDotParser.g:1178:3: (enumLiteral_1= Node )
                    // InternalDotParser.g:1179:4: enumLiteral_1= Node
                    {
                    enumLiteral_1=(Token)match(input,Node,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getAttributeTypeAccess().getNodeEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_1, grammarAccess.getAttributeTypeAccess().getNodeEnumLiteralDeclaration_1());
                      			
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalDotParser.g:1186:3: (enumLiteral_2= Edge )
                    {
                    // InternalDotParser.g:1186:3: (enumLiteral_2= Edge )
                    // InternalDotParser.g:1187:4: enumLiteral_2= Edge
                    {
                    enumLiteral_2=(Token)match(input,Edge,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getAttributeTypeAccess().getEdgeEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_2, grammarAccess.getAttributeTypeAccess().getEdgeEnumLiteralDeclaration_2());
                      			
                    }

                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAttributeType"

    // $ANTLR start synpred1_InternalDotParser
    public final void synpred1_InternalDotParser_fragment() throws RecognitionException {   
        // InternalDotParser.g:753:5: ( ( RULE_COMPASS_PT ) )
        // InternalDotParser.g:753:6: ( RULE_COMPASS_PT )
        {
        // InternalDotParser.g:753:6: ( RULE_COMPASS_PT )
        // InternalDotParser.g:754:6: RULE_COMPASS_PT
        {
        match(input,RULE_COMPASS_PT,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    // $ANTLR end synpred1_InternalDotParser

    // Delegated rules

    public final boolean synpred1_InternalDotParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_InternalDotParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA5 dfa5 = new DFA5(this);
    static final String dfa_1s = "\23\uffff";
    static final String dfa_2s = "\1\uffff\5\13\6\uffff\5\13\1\uffff\1\13";
    static final String dfa_3s = "\6\4\3\uffff\1\24\2\uffff\5\4\1\25\1\4";
    static final String dfa_4s = "\6\33\3\uffff\1\33\2\uffff\5\33\1\25\1\33";
    static final String dfa_5s = "\6\uffff\1\3\1\5\1\4\1\uffff\1\2\1\1\7\uffff";
    static final String dfa_6s = "\23\uffff}>";
    static final String[] dfa_7s = {
            "\1\7\2\uffff\3\6\10\uffff\1\7\1\uffff\1\1\1\2\1\3\1\4\3\uffff\1\5",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\11\1\13\1\10\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\11\1\13\1\10\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\11\1\13\1\10\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\11\1\13\1\10\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\11\1\13\1\10\1\13\1\uffff\6\13\3\uffff\1\13",
            "",
            "",
            "",
            "\1\15\1\14\1\16\1\17\3\uffff\1\20",
            "",
            "",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\21\1\13\1\uffff\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\21\1\13\1\uffff\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\21\1\13\1\uffff\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\21\1\13\1\uffff\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\13\2\uffff\3\13\2\12\1\uffff\1\21\1\13\1\uffff\1\13\1\uffff\6\13\3\uffff\1\13",
            "\1\22",
            "\1\13\2\uffff\3\13\2\12\2\uffff\1\13\1\uffff\1\13\1\uffff\6\13\3\uffff\1\13"
    };

    static final short[] dfa_1 = DFA.unpackEncodedString(dfa_1s);
    static final short[] dfa_2 = DFA.unpackEncodedString(dfa_2s);
    static final char[] dfa_3 = DFA.unpackEncodedStringToUnsignedChars(dfa_3s);
    static final char[] dfa_4 = DFA.unpackEncodedStringToUnsignedChars(dfa_4s);
    static final short[] dfa_5 = DFA.unpackEncodedString(dfa_5s);
    static final short[] dfa_6 = DFA.unpackEncodedString(dfa_6s);
    static final short[][] dfa_7 = unpackEncodedStringArray(dfa_7s);

    class DFA5 extends DFA {

        public DFA5(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 5;
            this.eot = dfa_1;
            this.eof = dfa_2;
            this.min = dfa_3;
            this.max = dfa_4;
            this.accept = dfa_5;
            this.special = dfa_6;
            this.transition = dfa_7;
        }
        public String getDescription() {
            return "207:3: (this_NodeStmt_0= ruleNodeStmt | this_EdgeStmtNode_1= ruleEdgeStmtNode | this_AttrStmt_2= ruleAttrStmt | this_Attribute_3= ruleAttribute | this_SubgraphOrEdgeStmtSubgraph_4= ruleSubgraphOrEdgeStmtSubgraph )";
        }
    }
 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x00000000000000E2L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000008F400E0L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000008F40000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000008FC0390L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000000C00L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000010C02L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000010002L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000008F20000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000008F25000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000008F00000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000000C02L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000008F40390L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000000002002L});

}